﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Objects;
using System.Data.Common;
using System.Data.EntityClient;
using System.Data;
using System.Data.SqlClient;

namespace ConsoleApplication
{
    class Program
    {
        static void Main(string[] args)
        {
            Listing_38_1();
            //Listing_38_2();
            //Listing_38_3();
            //Listing_38_4();
            //Listing_38_5();
            //Listing_38_6();
            //Listing_38_7();
            //Listing_38_8();
            //Listing_38_9();
            //Listing_38_10();
            //Listing_38_11();
            //Listing_38_12();
            //Listing_38_13();
            //Listing_38_14();
            //Listing_38_15();
            //Listing_38_16();
            //Listing_38_17();
            //Listing_38_18();
            //Listing_38_19();
            //Listing_38_20();
            //Listing_38_21();
            //Listing_38_22();
            //Listing_38_23();
            //Listing_38_24();
            //Listing_38_25();
            //Listing_38_26();
            //Listing_38_27();
            //Listing_38_28();

            Console.ReadLine();
        }

        static void Listing_38_1()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var products = context.Products;
                Console.WriteLine(products.ToTraceString());
                foreach (var prod in products)
                    Console.WriteLine("{0,-5}{1}", prod.ProductID, prod.ProductName);
            }

        }

        static void Listing_38_2()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var products = from p in context.Products
                               where p.UnitPrice >= 50
                               select new { p.ProductID, p.ProductName, p.UnitPrice };
                foreach (var prod in products)
                    Console.WriteLine("{0,-5}{1,-35}{2}",
                                       prod.ProductID, prod.ProductName, prod.UnitPrice);
            } 
        }

        static void Listing_38_3()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = (from prod in context.Products
                             where prod.ProductID == 22
                             select prod).SingleOrDefault();
                if (query != null)
                    Console.WriteLine("{0,-20}", query.ProductName);
                else
                    Console.WriteLine("Kein entsprechendes Element gefunden.");
            }
        }

        static void Listing_38_4()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                Console.Write("Wie viele DS überspringen?");
                int skip = Convert.ToInt32(Console.ReadLine());
                Console.Write("Wie viele DS anzeigen?");
                int count = Convert.ToInt32(Console.ReadLine());
                var query = (from prod in context.Products
                             orderby prod.ProductID
                             select prod).Skip(skip).Take(count);
                foreach (var item in query)
                    Console.WriteLine("{0,-4}{1}", item.ProductID, item.ProductName);
            }
        }

        static void Listing_38_5()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                List<Product> query = (from prod in context.Products
                                       where prod.UnitPrice < 10
                                       select prod).ToList();
                foreach (Product item in query)
                    Console.WriteLine("{0,-35}{1}", item.ProductName, item.UnitPrice);
            }
        }

        static void Listing_38_6()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = context.Products
                         .Select(p => new { p.ProductName, p.Category.CategoryName });
                foreach (var item in query)
                    Console.WriteLine("{0,-35}{1}", item.ProductName, item.CategoryName);
            }   
        }

        static void Listing_38_7()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = from prod in context.Products
                            orderby prod.Category.CategoryName, prod.ProductName
                            select new { prod.ProductName, prod.Category.CategoryName };
                foreach (var item in query)
                    Console.WriteLine("{0,-35}{1}", item.CategoryName, item.ProductName);
            }
        }

        static void Listing_38_8()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = from cat in context.Categories
                            where cat.CategoryID == 1 || cat.CategoryID == 8
                            select new { cat.CategoryName, Artikel = cat.Products };
                foreach (var item in query)
                {
                    Console.WriteLine("{0}", item.CategoryName);
                    foreach (var prod in item.Artikel)
                        Console.WriteLine("... {0}", prod.ProductName);
                    Console.WriteLine();
                }
            }
        }

        static void Listing_38_9()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = from cat in context.Categories
                            where cat.CategoryID == 1 || cat.CategoryID == 8
                            select new
                            {
                                cat.CategoryName,
                                Artikel = from prod in cat.Products
                                          select new
                                          {
                                              prod.ProductName,
                                              prod.UnitPrice
                                          }
                            };
                foreach (var item in query)
                {
                    Console.WriteLine(item.CategoryName);
                    foreach (var item2 in item.Artikel)
                        Console.WriteLine("...{0,-35}{1}", item2.ProductName, item2.UnitPrice);
                }
            }
        }

        static void Listing_38_10()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = from cat in context.Categories
                            where cat.Products.Any(prod => prod.SupplierID == 1)
                            select cat;
                foreach (var item in query)
                    Console.WriteLine(item.CategoryName);
            }

        }

        static void Listing_38_11()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = from cat in context.Categories
                            select new { cat.CategoryName, Count = cat.Products.Count() };
                foreach (var item in query)
                    Console.WriteLine("{0,-15}  {1}", item.CategoryName, item.Count);
            }
        }

        static void Listing_38_12()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = from prod in context.Products
                            where prod.UnitPrice == context.Products.Max(p => p.UnitPrice)
                            select new { prod.ProductName, prod.UnitPrice };
                foreach (var item in query)
                    Console.WriteLine("{0}, {1}", item.ProductName, item.UnitPrice);
            }
        }

        static void Listing_38_13()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = from cat in context.Categories
                            join prod in context.Products
                            on cat.CategoryID equals prod.CategoryID
                            orderby cat.CategoryName
                            select new { cat.CategoryName, prod.ProductName };
                foreach (var item in query)
                    Console.WriteLine("{0}...{1}", item.CategoryName, item.ProductName);
            }
        }

        static void Listing_38_14()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var results = from cat in context.Categories
                              join prod in context.Products
                              on cat.CategoryID equals prod.CategoryID
                              into listProd
                              from p in listProd.DefaultIfEmpty()
                              select new
                              {
                                  CatName = cat.CategoryName,
                                  ProdName = p.ProductName
                              };
                foreach (var item in results)
                    Console.WriteLine("{0,-15} ... {1}", item.CatName, item.ProdName);
            }
        }

        static void Listing_38_15()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var results = from prod in context.Products
                              join cat in context.Categories
                              on prod.CategoryID equals cat.CategoryID
                              into listProd
                              from p in listProd.DefaultIfEmpty()
                              select new
                              {
                                  CatName = p.CategoryName,
                                  ProdName = prod.ProductName
                              };
                foreach (var item in results)
                    Console.WriteLine("{0,-35}{1}", item.ProdName, item.CatName);
            }

        }

        static void Listing_38_16()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = from prod in context.Products
                            select new { prod, Kategorie = prod.Category };

                foreach (var item in query)
                    Console.WriteLine("{0,-35}{1}", item.prod.ProductName, item.Kategorie.CategoryName);
            }
        }

        static void Listing_38_17()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = context.Products;

                foreach (var item in query)
                    Console.WriteLine("{0,-35}{1}", item.ProductName, item.Category.CategoryName);
            }
        }

        static void Listing_38_18()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                context.ContextOptions.LazyLoadingEnabled = false;
                var query = from cat in context.Categories
                            select cat;
                foreach (var item in query)
                {
                    item.Products.Load();
                    Console.WriteLine("{0,-20} 'Anzahl: {1}", item.CategoryName, item.Products.Count);
                }
            }
        }

        static void Listing_38_19()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                context.ContextOptions.LazyLoadingEnabled = false;
                var query = from cat in context.Categories
                            select cat;
                foreach (var item in query)
                {
                    Console.WriteLine(item.CategoryName);
                    if (item.CategoryName == "Beverages")
                    {
                        item.Products.Load();
                        Console.WriteLine("Anzahl: {0}", item.Products.Count());
                    }
                    Console.WriteLine();
                }
            }

        }

        static void Listing_38_20()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = from cat in context.Categories.Include("Products")
                            select cat;
                foreach (var item in query)
                {
                    Console.WriteLine(item.CategoryName);
                    foreach (Product prod in item.Products)
                        Console.WriteLine("  {0}", prod.ProductName);
                }
            }

        }

        static void Listing_38_21()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = "SELECT VALUE p FROM NorthwindEntities.Products AS p " +
                             "WHERE p.UnitPrice > 50";
                ObjectQuery<Product> products = context.CreateQuery<Product>(query);
                foreach (Product item in products)
                    Console.WriteLine(item.ProductName);
            }

        }

        static void Listing_38_22()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query = "SELECT p.ProductName, p.UnitPrice FROM NorthwindEntities.Products AS p";
                var products = new ObjectQuery<DbDataRecord>(query, context);
                foreach (var item in products)
                    Console.WriteLine(item.GetValue(0));
            }
        }

        static void Listing_38_23()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                string query = "SELECT VALUE p FROM northwindentities.products AS p " +
                               "WHERE p.Discontinued = true";
                ObjectQuery<Product> products = new ObjectQuery<Product>(query, context);
                foreach (var item in products)
                    Console.WriteLine(item.ProductName);
            }
        }

        static void Listing_38_24()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                string query = "SELECT VALUE p FROM NorthwindEntities.Products AS p " +
                               "WHERE p.UnitPrice > @preis";
                ObjectQuery<Product> products = context.CreateQuery<Product>(query);
                products.Parameters.Add(new ObjectParameter("preis", 50));
                foreach (Product item in products)
                    Console.WriteLine("{0,-35}{1}", item.ProductName, item.UnitPrice);
            }
        }

        static void Listing_38_25()
        {
            EntityConnection con = new EntityConnection("Name=NorthwindEntities");
            con.Open();
            string query = "SELECT VALUE p FROM NorthwindEntities.Products As p";
            EntityCommand cmd = new EntityCommand();
            cmd.CommandText = query;
            cmd.Connection = con;
            EntityDataReader reader = cmd.ExecuteReader(CommandBehavior.SequentialAccess);
            while (reader.Read())
            {
                Console.WriteLine("{0,-4}{1}", reader["ProductID"], reader["ProductName"]);
            }
            reader.Close();
            con.Close();
            Console.ReadLine();
        }

        static void Listing_38_26()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                DbConnection con = (context.Connection as EntityConnection).StoreConnection;
                con.Open();
                Console.WriteLine("Verbindungszeichenfolge:");
                Console.WriteLine(con.ConnectionString + "\n");
                DbCommand cmd = con.CreateCommand();
                cmd.CommandText = "SELECT * FROM Products";
                DbDataReader reader = cmd.ExecuteReader();

                while (reader.Read())
                {
                    Console.WriteLine(reader[1]);
                }
            }
        }

        static void Listing_38_27()
        {
            using(NorthwindEntities context= new NorthwindEntities())
            {
                Console.Write("Preise ab: ");
                decimal price = Convert.ToDecimal(Console.ReadLine());
                Console.Write("Kategorie-ID: ");
                int catID = Convert.ToInt32(Console.ReadLine());

                var query = context.Products
                            .Where("it.Unitprice > @price AND it.CategoryID==@cat",
                                    new ObjectParameter("price", price),
                                    new ObjectParameter("cat", catID))
                            .Select("it.ProductName, it.UnitPrice");

                foreach (var item in query)
                    Console.WriteLine("{0,-35}{1}", item.GetValue(0), item.GetValue(1));
            }
        }

        static void Listing_38_28()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                Console.Write("Preise ab ... ");
                decimal price = Convert.ToDecimal(Console.ReadLine());
                var query = context.ExecuteStoreQuery<Product>("SELECT * FROM Products WHERE UnitPrice > @price", new object[] {new SqlParameter("@price", price)});

                foreach (var item in query)
                    Console.WriteLine(item.ProductName);
            }
        }
    }
}
