﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.Objects;
using System.Data.Common;
using System.Data;

namespace ConsoleApplication
{
    class Program
    {
        static void Main(string[] args)
        {
            Listing_39_1();
            //Listing_39_2();
            //Listing_39_3();
            //Listing_39_4();
            //Listing_39_5();
            //Listing_39_6();
            //Listing_39_7();
            //Listing_39_8();
            //Listing_39_9();
            //Listing_39_10();
            //Listing_39_11();
            //Listing_39_12();
            //Listing_39_13();
            //Listing_39_14();
            //Listing_39_15();
            Console.ReadLine();
        }


        static void Listing_39_1()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var prod = (context.Products
                                  .Select(p => p)).SingleOrDefault(p => p.ProductID == 1);
                if (prod != null)
                {
                    prod.ProductName = "Aachener Printen";
                    prod.UnitsInStock = 0;
                    // Änderung in die Datenbank schreiben
                    context.SaveChanges();
                    Console.WriteLine("Datenbank aktualisiert...");
                }
                else
                    Console.WriteLine("Der Artikel wurde nicht gefunden.");
            }
        }

        static void Listing_39_2()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                // alle Produkte abfragen
                var query = context.Products.Select(p => p).ToList();
                // Produkte herausfiltern, deren Lagerbestand <= 20 ist
                var prods = query
                            .Where(p => p.UnitsInStock <= 20)
                            .Select(p => p);
                // Lagerbestand erhöhen
                foreach (var item in prods)
                    item.UnitsInStock = 100;
                int count = context.SaveChanges();
                Console.WriteLine("Datenbank aktualisiert ({0} Datensätze).", count);
            }
        }

        static void Listing_39_3()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                Product product = new Product();
                product.ProductName = "Schokolade";
                product.Discontinued = false;
                // oder: Product product = Product.CreateProduct(99, "Kuchen", false);
                context.AddToProducts(product);
                context.SaveChanges();
                Console.WriteLine("Datenbank aktualisiert...");
                Console.WriteLine("Neue ID: {0}", product.ProductID);
            }

        }

        static void Listing_39_4()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                Category newCat = Category.CreateCategory(-1, "Backwaren");
                Product newProduct = new Product();
                newProduct.ProductID = 0;
                newProduct.ProductName = "Jubel's Eierkuchen";
                newProduct.Discontinued = false;
                newProduct.Category = newCat;
                context.AddToCategories(newCat);
                context.SaveChanges();
                Console.WriteLine("Datenbank aktualisiert ...");
            }

        }

        static void Listing_39_5()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var prod = context.Products
                                  .Select(p => p).First(p => p.ProductID == 78);
                context.DeleteObject(prod);
                context.SaveChanges();
                Console.WriteLine("Artikel gelöscht.");
            }
        }

        static void Listing_39_6()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var prod = context.Products.First(p => p.ProductID == 2);
                var orders = context.Order_Details
                                    .Where(order => order.ProductID == prod.ProductID);
                context.DeleteObject(prod);
                foreach (var item in orders)
                    context.DeleteObject(item);
                context.SaveChanges();
                Console.WriteLine("Artikel samt der Bestellungen gelöscht.");
            }

        }

        static void Listing_39_7()
        {
            using (NorthwindEntities context1 = new NorthwindEntities())
            {
                Product product = context1.Products.First();
                product.ProductName = "Brathering";
                Console.WriteLine("Im context1: {0}", product.EntityState);
                // Entfernen der Entität aus dem aktuellen Objektkontext
                context1.Detach(product);
                Console.WriteLine("Ohne Context: {0}", product.EntityState);

                using (NorthwindEntities context2 = new NorthwindEntities())
                {
                    // Hinzufügen der Entität zum neuen Objektkontext
                    context2.Attach(product);
                    Console.WriteLine("Im context2: {0}", product.EntityState);
                }
            }
        }

        static void Listing_39_8()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query1 = from prod in context.Products
                             where prod.UnitPrice >= 50
                             select prod;
                ((ObjectQuery)query1).MergeOption = MergeOption.NoTracking;
                var query2 = query1.First();
                Console.WriteLine(query2.EntityState);
            }

        }

        static void Listing_39_9()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var query1 = from prod in context.Products
                             where prod.UnitPrice >= 50
                             select prod;
                context.Products.MergeOption = MergeOption.NoTracking;
                var query2 = query1.First();
                Console.WriteLine(query2.EntityState);
            }

        }

        static void Listing_39_10()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                context.Products.MergeOption = MergeOption.NoTracking;
                var query1 = from prod in context.Products
                             where prod.UnitPrice >= 50
                             select prod;
                var query2 = query1.First();
                
                Console.WriteLine(query2.EntityState);
            }

        }

        static void Listing_39_11()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var cat = (context.Categories
                           .Where(c => c.CategoryID == 1)
                           .Select(c => c)).First();
                // Kategoriebezeichner ändern
                cat.CategoryName = "Getränke";
                // ObjectStateEntry abfragen
                ObjectStateManager osm = context.ObjectStateManager;
                ObjectStateEntry entry = osm.GetObjectStateEntry(cat);
                // aktuellen Wert abrufen
                DbDataRecord actValues = entry.CurrentValues;
                Console.WriteLine("Aktueller Wert: {0}", actValues.GetValue(actValues.GetOrdinal("CategoryName")));
                // Originalwert abrufen
                DbDataRecord origValues = entry.OriginalValues;
                Console.WriteLine("Originalwert: {0}", origValues.GetValue(origValues.GetOrdinal("CategoryName")));
            }

        }

        static void Listing_39_12()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                Product prod = new Product()
                {
                    ProductName = "Kuchen",
                    Discontinued = false
                };
                context.AddToProducts(prod);
                var osm = context.ObjectStateManager;
                ObjectStateEntry entry;
                if (osm.TryGetObjectStateEntry(prod, out entry))
                {
                    var ordinal = entry.CurrentValues.GetOrdinal("ProductName");
                    Console.WriteLine(entry.CurrentValues.GetValue(ordinal));
                }
                else
                    Console.WriteLine("Objekt nicht im 'ObjectStateManager'");
            }

        }

        static void Listing_39_13()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                // einen Artikel dem Kontext zuordnen und editieren
                var prod = context.Products
                                  .Select(p => p).First(p => p.ProductID == 1);
                prod.ProductName = "Spülmittel";
                // einen neuen Artikel anlegen
                Product product = new Product()
                {
                    ProductName = "Senf",
                    Discontinued = false
                };
                context.AddToProducts(product);

                // alle Produkte abfragen, die geändert oder hinzugefügt worden sind
                ObjectStateManager osm = context.ObjectStateManager;
                var items = osm.GetObjectStateEntries(EntityState.Modified | EntityState.Added);
                foreach (var item in items)
                {
                    var values = item.CurrentValues;
                    Console.WriteLine(values.GetValue(values.GetOrdinal("ProductName")));
                }
            }

        }

        static void Listing_39_14()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                var product = (context.Products
                                      .Where(prod => prod.ProductID == 1)
                                      .Select(prod => prod)).First();
                product.ProductName = "Orangensaft";
                product.UnitPrice = (decimal?)2.98;
                product.UnitsInStock = 10;
                ObjectStateManager osm = context.ObjectStateManager;
                ObjectStateEntry entry = osm.GetObjectStateEntry(product);
                // die Liste der veränderten Eigenschaften ausgeben
                foreach (var item in entry.GetModifiedProperties())
                    Console.WriteLine(item);
                Console.ReadLine();
            }

        }

        static void Listing_39_15()
        {
            using (NorthwindEntities context = new NorthwindEntities())
            {
                EntityKey key = new EntityKey("NorthwindEntities.Products",
                                              "ProductID", 92);
                object @object;
                if (context.TryGetObjectByKey(key, out @object))
                {
                    Product product = (Product)@object;
                    Console.WriteLine(product.ProductName);
                }
                else
                    Console.WriteLine("Kann passendes Objekt zum Löschen gefunden.");
            }

        }
    }
}
