﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace EventDemonstration
{
  class Program
  {
    static void Main(string[] args)
    {
      Demo demo = new Demo();
      demo.OutOfCoffee += new EventHandler(demo_OutOfCoffee);
      demo.DoSomething();
      Console.ReadLine();
    }

    // Ereignishandler
    static void demo_OutOfCoffee(object sender, EventArgs e)
    {
      Console.WriteLine("Im Ereignishandler von 'OutOfCoffee'");
    }
  }

  class Demo
  {
    // Gekapselter Delegate
    private EventHandler _OutOfCoffee;

    // Definition des Events
    public event EventHandler OutOfCoffee
    {
      add { _OutOfCoffee += value; }
      remove { _OutOfCoffee -= value; }
    }

    // Ereignisauslösende Methode
    public void DoSomething()
    {
      if (_OutOfCoffee != null)
        this._OutOfCoffee(this, new EventArgs());
    }
  }

}
