﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace GeometricObjects
{
  // Delegates
  public delegate void InvalidMeasureEventHandler(Object sender, InvalidMeasureEventArgs e);
  public delegate void MovingEventHandler(Object sender, MovingEventArgs e);
  public delegate void MovedEventHandler(Object sender, EventArgs e);

  // EventArgs-Klassen
  public class MovingEventArgs : EventArgs
  {
    public bool Cancel { get; set; }
  }

  public class InvalidMeasureEventArgs : EventArgs
  {
    // Felder
    private int _InvalidMeasure;
    private string _PropertyName = "[unkonwn]";

    // Eigenschaften
    public int InvalidMeasure
    {
      get { return _InvalidMeasure; }
    }

    public string PropertyName
    {
      get { return _PropertyName; }
    }

    // Konstruktor
    public InvalidMeasureEventArgs(int invalidMeasure, string propertyName)
    {
      _InvalidMeasure = invalidMeasure;
      if (propertyName == "" || propertyName == null)
        _PropertyName = "[unknown]";
      else 
        _PropertyName = propertyName;
    }
  }
}
